;;; uws-mode.l
;;;
;;; Last updated: "2005/01/13 01:15:10 +0900"
;;;
;;; o鎖F L[[hFtE⊮ACfg(r[)
;;;
;;; gF
;;; xyzzyCXg[tH_/etc ɁAL[[ht@C "UWS"A
;;; xyzzyCXg[tH_/site-lisp ɁAuws-mode.l Rs[B
;;; .xyzzy 邢 siteinit.lɁAȉ̂悤ɋLqB
;;; 
;;; (require "uws-mode")
;;; (pushnew '("\\.uws$" . uws-mode) *auto-mode-alist* :test 'equal)
;;;
;;; --------------------
;;;
;;; http://kadd.hp.infoseek.co.jp/foomode.html
;;; mode쐬evRsyĎg킹Ă炢܂BӁB
;;;
;;; ĉłAǂ c-mode Ƃ͐FXႤ݂Łuws
;;; Ȃ̂ŁAbasic-mode RsyĂĎĂ݂B


;;; ȍ~Abasic-mode 炻̂܂܃RsyB
;;; s/basci/uws/ A
;;; block֌W̃L[[hA
;;; ʎgȂł낤Ƃ̓RgAEgB


(provide "uws-mode")

(in-package "editor")

(export '(
		  *uws-mode-hook*
		  *uws-mode-map*
		  uws-mode
		  *uws-mode-abbrev-table*
		  *uws-mode-syntax-table*
		  *uws-indent-level*
		  *uws-continued-line-offset*
		  *uws-label-offset*
		  *uws-tab-always-indent*
		  *uws-auto-close*
		  *uws-auto-cap*
		  *uws-auto-correct-else-if*
		  *uws-auto-correct-then*
		  *uws-auto-correct-operators*
		  *uws-comment-column*
		  *uws-popup-completion-list*
		  uws-indent-line
		  uws-newline-and-indent
;; 		  uws-electric-close
;; 		  uws-electric-cap
;; 		  uws-forward-block
;; 		  uws-backward-block
;; 		  uws-beginning-of-defun
;; 		  uws-end-of-defun
;; 		  uws-correct-operators
;; 		  uws-indent-sexp
		  uws-completion
		  ))

(defvar *uws-indent-level* 4)
(defvar *uws-continued-line-offset* 4)
(defvar *uws-label-offset* -4)
(defvar *uws-tab-always-indent* t)
(defvar *uws-auto-close* t)
(defvar *uws-auto-cap* t)
(defvar *uws-auto-correct-then* t)
(defvar *uws-auto-correct-else-if* t)
(defvar *uws-auto-correct-operators* t)
(defvar *uws-mode-hook* nil)
(defvar *uws-comment-column* nil)
(defvar *uws-popup-completion-list* nil)

(defvar *uws-mode-map* nil)
(unless *uws-mode-map*
  (setq *uws-mode-map* (make-sparse-keymap))
  (define-key *uws-mode-map* #\TAB 'uws-indent-line)
  (define-key *uws-mode-map* #\RET 'uws-newline-and-indent)
;;   (define-key *uws-mode-map* #\SPC 'uws-electric-close)
;;   (define-key *uws-mode-map* #\# 'uws-electric-insert)
;;   (define-key *uws-mode-map* #\: 'uws-electric-insert)
;;   (define-key *uws-mode-map* #\( 'uws-electric-cap)
;;   (define-key *uws-mode-map* #\$ 'uws-electric-cap)
;;   (define-key *uws-mode-map* #\= 'uws-correct-operators)
;;   (define-key *uws-mode-map* #\& 'uws-correct-operators)
;;   (define-key *uws-mode-map* #\| 'uws-correct-operators)
  (define-key *uws-mode-map* '(#\ESC #\TAB) 'uws-completion)
;;   (define-key *uws-mode-map* #\C-M-q 'uws-indent-sexp)
  (define-key *uws-mode-map* #\C-h 'backward-delete-char-untabify-or-selection))

(defvar *uws-keyword-hash-table* nil)
(defvar *uws-keyword-file* "uws")
(defvar *uws-keyword-cap-table* nil)
(defvar *uws-completion-list* nil)

(defvar *uws-mode-syntax-table* nil)
(unless *uws-mode-syntax-table*
  (setq *uws-mode-syntax-table* (make-syntax-table))
  (do ((x #x21 (1+ x)))
      ((>= x #x7f))
    (let ((c (code-char x)))
      (unless (alphanumericp c)
	(set-syntax-punctuation *uws-mode-syntax-table* c))))
  (set-syntax-string *uws-mode-syntax-table* #\")
  (set-syntax-symbol *uws-mode-syntax-table* #\_)
  (set-syntax-match *uws-mode-syntax-table* #\( #\))
  (set-syntax-start-comment *uws-mode-syntax-table* #\/ )
  (set-syntax-end-comment *uws-mode-syntax-table* #\LFD nil t))

(defvar *uws-mode-abbrev-table* nil)
(unless *uws-mode-abbrev-table*
  (define-abbrev-table '*uws-mode-abbrev-table*))

(defvar *uws-block-begin-regexp*
  (compile-regexp
   "\\(For\\|If\\|Ifb\\|Select\\|While\\|Repeat\\|Function\\|Procedure\\)\\([^A-Za-z0-9_]\\|$\\)" t))

(defvar *uws-block-end-regexp*
  (compile-regexp "\\(Endif\\|Next\\|Wend\\|Until\\|Selend\\|Fend\\)\\([^A-Za-z0-9_\n]\\|$\\)" t))

(defvar *uws-block-mid-regexp*
  (compile-regexp "\\(ElseIf\\|Else\\|Case\\|Default\\)\\([^A-Za-z0-9_\n]\\|$\\)" t))

(defvar *uws-label-regexp*
  (compile-regexp "\\([A-Za-z0-9_]\\|\\sk\\|\\sj\\)+[ \t]*:" t))

(defvar *uws-comment-regexp* "[\\/#]")

(defvar *uws-procedure-regexp*
  (compile-regexp
   "^[ \t]+\\(\\(Function\\|Procedure\\)\\|Fend[ \t]*\\)\\([^A-Za-z0-9_]\\|$\\)" t))

(defvar *uws-block-regexp*
  (compile-regexp
   "^[ \t]*\\(For\\|If\\|Ifb\\|Select\\|While\\|Repeat\\|Next\\|Endif\\|Selend\\|Wend\\|Until\\)\\([^A-Za-z0-9_]\\|$\\)" t))

;; (defvar *uws-beginning-of-defun-noname-regexp*
;;   "^[ \t]*\\(Function\\|Procedure\\)[ \t]+")

;; (defvar *uws-beginning-of-defun-regexp*
;;   (compile-regexp (concat *uws-beginning-of-defun-noname-regexp* "\\([A-Za-z0-9_]+\\)") t))

;; (defvar *uws-end-of-defun-regexp*
;;   (compile-regexp "^[ \t]*Fend\\([ \t]+\\|$\\)" t))

;; (pushnew '(uws-maketags "*.bas" "*.frm" "*.mb") *maketags-list* :key #'car)

;; (defun uws-maketags (file count)
;;   (goto-char (point-min))
;;   (while (scan-buffer *uws-beginning-of-defun-regexp* :regexp t :case-fold t :tail t)
;;     (do-events)
;;     (format t "~A~A~D - ~A" (match-string 4) file (match-beginning 0) file)
;;     (incf count))
;;   count)

;; (defun tags-find-uws-point (class name functionp point)
;;   (goto-char (- point *jump-tag-limit*))
;;   (and (scan-buffer (concat *uws-beginning-of-defun-noname-regexp*
;; 			    (regexp-quote name)
;; 			    "[ \t]+")
;; 		    :regexp t :case-fold t :limit (+ point *jump-tag-limit*))
;;        (point)))

;; (defun uws-build-summary-of-functions ()
;;   (let ((result nil))
;;     (save-excursion
;;       (goto-char (point-min))
;;       (while (scan-buffer *uws-beginning-of-defun-regexp* :regexp t :case-fold t :tail t)
;; 	(push (list (current-line-number) (match-string 4)) result)))
;;     (nreverse result)))

;; (defun uws-beginning-of-defun (&optional (arg 1))
;;   (interactive "p")
;;   (cond ((plusp arg)
;; 	 (dotimes (i arg t)
;; 	   (unless (scan-buffer *uws-beginning-of-defun-regexp*
;; 				:regexp t :case-fold t :reverse t :no-dup t)
;; 	     (goto-char (point-min))
;; 	     (return nil))))
;; 	((minusp arg)
;; 	 (dotimes (i (- arg) t)
;; 	   (unless (scan-buffer *uws-end-of-defun-regexp* :regexp t :case-fold t)
;; 	     (goto-char (point-max))
;; 	     (return nil))
;; 	   (or (forward-line 1)
;; 	       (goto-eol))))))

;; (defun uws-end-of-defun (&optional (arg 1))
;;   (interactive "p")
;;   (uws-beginning-of-defun (- arg)))


;; CfgɕKv

(defun uws-continuation-line-p (&optional (n -3))
  (save-excursion
    (and (forward-char n)
	 (looking-at "\\(^\\|[^A-Za-z0-9_]\\)_"))))


;; CfgɕKv

(defun uws-eol-p ()
  (save-restriction
    (narrow-to-region (point) (progn (goto-eol) (point)))
    (goto-char (point-min))
    (skip-white-forward)
    (eolp)))


;; CfgɕKv

(defun uws-single-line-if-p ()
  (save-excursion
    (save-restriction
      (narrow-to-region
       (point)
       (progn
	 (loop
	   (unless (forward-line 1)
	     (goto-eol)
	     (return))
	   (unless (uws-continuation-line-p)
	     (return)))
	 (point)))
      (goto-char (point-min))
      (while (forward-sexp 1 t)
	(when (and (looking-back "Then" t)
		   (save-excursion
		     (= (- (point) 4) (progn (forward-sexp -1 t) (point)))))
	  (return (not (uws-eol-p))))))))


;; CfgɕKv

(defun uws-in-procedure-level-p ()
  (and (scan-buffer *uws-procedure-regexp* :regexp t :reverse t :case-fold t)
       (not (looking-for "End" t))))


;; (defun uws-in-comment-or-string-p ()
;;   (save-excursion
;;     (let ((end (point)))
;;       (goto-bol)
;;       (while (scan-buffer "[\/\"]" :regexp t :limit end)
;; 	(when (or (looking-for "/")
;; 		  (not (scan-buffer "\"" :limit end :tail t :no-dup t)))
;; 	  (return t))))))


;; CfgɕKv

(defun uws-end-stmt-p ()
  (save-excursion
    (and (progn
	   (forward-char 3)
	   (uws-eol-p))
	 (uws-in-procedure-level-p))))


;; CfgɕKv

(defun calc-uws-indent ()
  (save-excursion
    (goto-bol)
    (when (looking-at "[ \t]*#")
      (return-from calc-uws-indent 0))
    (let* ((single-line-if-p nil)
	   (column
	    (save-excursion
	      (loop
		(or (forward-line -1)
		    (return 0))
		(unless (uws-continuation-line-p)
		  (skip-chars-forward " \t")
		  (cond ((eolp))
			((looking-at *uws-comment-regexp*))
			((looking-at *uws-label-regexp*))
			((looking-at *uws-block-begin-regexp* t)
			 (if (and (looking-for "If" t)
				  (uws-single-line-if-p))
			     (progn
			       (setq single-line-if-p t)
			       (return (current-column)))
			   (return (+ (current-column) *uws-indent-level*))))
			((looking-at *uws-block-end-regexp* t)
			 (return (current-column)))
			((looking-at *uws-block-mid-regexp* t)
			 (return (+ (current-column) *uws-indent-level*)))
			(t
			 (return (current-column)))))))))
      (goto-bol)
      (if (uws-continuation-line-p)
	  (progn
	    (if single-line-if-p
		(incf column *uws-indent-level*))
	    (incf column *uws-continued-line-offset*))
	(progn
	  (skip-chars-forward " \t")
	  (cond ((looking-at *uws-block-end-regexp* t)
		 (unless (and (looking-for "End" t)
			      (uws-end-stmt-p))
		   (decf column *uws-indent-level*)))
		((looking-at *uws-block-mid-regexp* t)
		 (decf column *uws-indent-level*))
		((looking-at *uws-label-regexp*)
		 (incf column *uws-label-offset*)))))
      (max column 0))))


;; CfgɕKv

(defun uws-indent-mid-or-end-block ()
  (when (save-excursion
	  (let ((point (point)))
	    (goto-bol)
	    (skip-chars-forward " \t")
	    (and (or (looking-at *uws-block-mid-regexp* t)
		     (looking-at *uws-block-end-regexp* t))
		 (= point (match-end 0)))))
    (uws-indent-line)))


;; CfgɕKv

(defun uws-indent-line ()
  (interactive "*")
  (if (or (not (interactive-p))
	  *uws-tab-always-indent*
	  (save-excursion
	    (skip-chars-backward " \t")
	    (bolp)))
      (smart-indentation (calc-uws-indent))
    (insert "\t"))
  t)


;; CfgɕKv

(defun uws-newline-and-indent (&optional (arg 1))
  (interactive "*p")
  (uws-auto-cap)
  (when *uws-auto-correct-then*
    (uws-correct-then))
  (delete-trailing-spaces)
  (let ((eol (point)))
    (insert #\LFD arg)
    (save-excursion
      (goto-char eol)
      (uws-indent-mid-or-end-block)))
  (uws-indent-line))

;; (defun uws-indent-sexp ()
;;   (interactive "*")
;;   (indent-region (point)
;; 		 (save-excursion
;; 		   (uws-forward-block)
;; 		   (or (forward-line 1)
;; 		       (goto-eol))
;; 		   (point))))

;; (defun uws-electric-insert (&optional (arg 1))
;;   (interactive "*p")
;;   (self-insert-command arg)
;;   (unless (uws-in-comment-or-string-p)
;;     (uws-indent-line))
;;   t)


;; CfgɕKv

(defun uws-correct-then ()
  (let ((end (point)))
    (when (uws-continuation-line-p -2)
      (return-from uws-correct-then))
    (save-excursion
      (goto-bol)
      (while (and (uws-continuation-line-p)
		  (forward-line -1)))
      (skip-chars-forward " \t")
      (unless (looking-at "\\(If\\|ElseIf\\)\\([^A-Za-z0-9_]\\|$\\)" t)
	(return-from uws-correct-then))
      (save-restriction
	(narrow-to-region (point) end)
	(goto-char (point-min))
	(while (forward-sexp 1 t)
	  (when (and (looking-back "Then" t)
		     (save-excursion
		       (= (- (point) 4) (progn (forward-sexp -1 t) (point)))))
	    (return-from uws-correct-then)))
	(goto-char (point-min))
	(loop
	  (unless (scan-buffer "['\"]" :regexp t)
	    (goto-char (point-max))
	    (return))
	  (when (looking-for "'")
	    (return))
	  (unless (scan-buffer "\"" :tail t :no-dup t)
	    (return-from uws-correct-then)))
	(skip-chars-backward " \t")
	(insert " Then")))
    (goto-char (+ end 5))))

;; (defun uws-correct-operators (&optional (arg 1))
;;   (interactive "p")
;;   (if (and *uws-auto-correct-operators*
;; 	   (eql *last-command-char* (preceding-char))
;; 	   (not (uws-in-comment-or-string-p)))
;;       (case *last-command-char*
;; 	(#\=)
;; 	(#\&
;; 	 (delete-region (point) (1- (point)))
;; 	 (insert "And"))
;; 	(#\|
;; 	 (delete-region (point) (1- (point)))
;; 	 (insert "Or"))
;; 	(t
;; 	 (self-insert-command arg)))
;;     (self-insert-command arg)))


;; (defun uws-ident-equal (i)
;;   (and (looking-for i t)
;;        (save-excursion
;; 	 (forward-char (length i))
;; 	 (looking-at "[^A-Za-z0-9_]\\|$"))))



;; (defun uws-stmt-type ()
;;   (while (progn
;; 		   (skip-chars-forward " \t")
;; 		   (looking-at "Public" t))
;; 	(goto-char (match-end 0)))
;;   (cond
;;    ((looking-for "For" t) (values 'for t))
;;    ((looking-for "Next" t) 'for)
;;    ((looking-for "While" t) (values 'while t))
;;    ((looking-for "Wend" t) 'while)
;;    ((looking-for "If" t)
;; 	(unless (uws-single-line-if-p)
;; 	  (values 'if t)))
;;    ((looking-for "Select" t) (values 'select t))
;;    ((looking-for "Function" t) (values 'function t))
;;    ((looking-for "Procedure" t) (values 'Procedure t))
;;    ((looking-for "End" t)
;; 	(unless (uws-end-stmt-p)
;; 	  (forward-char 3)
;; 	  (skip-chars-forward " \t")
;; 	  (cond
;; 	   ((uws-ident-equal "If") 'if)
;; 	   ((uws-ident-equal "Select") 'select)
;; 	   ((uws-ident-equal "Function") 'function)
;; 	   ((uws-ident-equal "Procedure") 'Procedure)
;; 	   ((uws-eol-p) 'begin)
;; 	   (t nil))))
;;    (t nil)))


;; (defun uws-forward-block-1 (match)
;;   (unless (while (scan-buffer *uws-block-regexp* :regexp t :case-fold t)
;; 	    (multiple-value-bind (type open)
;; 		(uws-stmt-type)
;; 	      (cond ((null type))
;; 		    (open
;; 		     (unless (forward-line 1)
;; 		       (return nil))
;; 		     (uws-forward-block-1 type))
;; 		    ((eq type match)
;; 		     (return t))
;; 		    (t
;; 		     (return nil)))
;; 	      (unless (forward-line 1)
;; 		(return nil))))
;;     (error "Unmatched ~a" match))
;;   match)


;; (defun uws-forward-block ()
;;   (interactive)
;;   (let ((point (save-excursion
;; 		 (goto-bol)
;; 		 (when (looking-at *uws-block-regexp* t)
;; 		   (multiple-value-bind (type open)
;; 		       (uws-stmt-type)
;; 		     (when (and open (forward-line 1))
;; 		       (uws-forward-block-1 type)
;; 		       (point)))))))
;;     (when point
;;       (goto-char point)
;;       (goto-bol)
;;       (skip-chars-forward " \t")
;;       t)))


;; (defun uws-backward-block-1 (match)
;;   (unless (while (scan-buffer *uws-block-regexp* :regexp t :case-fold t :reverse t)
;; 	    (multiple-value-bind (type open)
;; 		(uws-stmt-type)
;; 	      (cond ((null type))
;; 		    ((not open)
;; 		     (unless (forward-line -1)
;; 		       (return nil))
;; 		     (uws-backward-block-1 type))
;; 		    ((eq type match)
;; 		     (return t))
;; 		    ((eq match 't)
;; 		     (setq match type)
;; 		     (return t))
;; 		    (t
;; 		     (return nil))))
;; 	    (unless (forward-line -1)
;; 	      (return nil)))
;;     (error "Unmatched ~a" match))
;;   match)


;; (defun uws-backward-block ()
;;   (interactive)
;;   (let ((point (save-excursion
;; 		 (goto-bol)
;; 		 (when (looking-at *uws-block-regexp* t)
;; 		   (multiple-value-bind (type open)
;; 		       (uws-stmt-type)
;; 		     (when (and type (not open) (forward-line -1))
;; 		       (uws-backward-block-1 type)
;; 		       (point)))))))
;;     (when point
;;       (goto-char point)
;;       (goto-bol)
;;       (skip-chars-forward " \t")
;;       t)))


;; CfgɕKv

(defun uws-auto-cap ()
  (when (and *uws-auto-cap*
	     (hash-table-p *uws-keyword-cap-table*))
    (save-excursion
      (let ((end (point)))
	(when (skip-chars-backward "A-Za-z0-9_")
	  (let ((kwd (gethash-region (point) end *uws-keyword-cap-table*)))
	    (when (and kwd
		       (= (length kwd) (- end (point)))
		       (not (looking-for kwd)))
	      (insert kwd)
	      (delete-region (point) (+ (point) (length kwd))))))))))

;; (defun uws-electric-cap (&optional (arg 1))
;;   (interactive "*p")
;;   (unless (uws-in-comment-or-string-p)
;;     (uws-auto-cap))
;;   (self-insert-command arg))

;; (defun uws-electric-close (&optional (arg 1))
;;   (interactive "*p")
;;   (if (uws-in-comment-or-string-p)
;;       (self-insert-command arg)
;;     (progn
;;       (uws-auto-cap)
;;       (if (and *uws-auto-close*
;; 	       (save-excursion
;; 		 (let ((point (point)))
;; 		   (goto-bol)
;; 		   (skip-chars-forward " \t")
;; 		   (and (looking-for "End" t)
;; 			(= (+ (point) 3) point)))))
;; 	  (let (open)
;; 	    (case (save-excursion
;; 		    (and (forward-line -1)
;; 			 (prog1
;; 			     (uws-backward-block-1 't)
;; 			   (setq open (point)))))
;; 		  (if (insert " If"))
;; 		  (select (insert " Select"))
;; 	      (function (insert " Function"))
;; 	      (Procedure (insert " Procedure"))
;; 	      (begin)
;; 	      (do (delete-region (point) (- (point) 3))
;; 		  (insert "Loop"))
;; 	      (for (delete-region (point) (- (point) 3))
;; 		   (insert "Next"))
;; 	      (while (delete-region (point) (- (point) 3))
;; 		(insert "Wend"))
;; 	      (begin-property (delete-region (point) (- (point) 3))
;; 			      (insert "EndProperty"))
;; 	      (t
;; 	       (error "Unmatched End")))
;; 	    (uws-indent-line)
;; 	    (save-excursion
;; 	      (goto-char open)
;; 	      (show-matched-parenthesis)))
;; 	(progn
;; 	  (uws-correct-else-if)
;; 	  (self-insert-command arg)
;; 	  (uws-indent-mid-or-end-block)))))
;;   t)

;; (defun uws-correct-else-if ()
;;   (save-excursion
;;     (let ((point (point)))
;;       (goto-bol)
;;       (skip-chars-forward " \t")
;;       (when (and (looking-at "Else[ \t]+If" t)
;; 		 (= point (match-end 0)))
;; 	(delete-region (+ (match-beginning 0) 4) (- (match-end 0) 2))))))


;; ⊮ɕKv

(defun uws-completion ()
  (interactive)
  (or *uws-completion-list*
      (setq *uws-completion-list* (make-list-from-keyword-table *uws-keyword-hash-table*))
      (return-from uws-completion nil))
  (let ((opoint (point)))
    (when (skip-chars-backward "A-Za-z0-9_")
      (let ((from (point)))
	(goto-char opoint)
	(do-completion from opoint :list-ignore-case *uws-completion-list*
		       nil nil *uws-popup-completion-list*)))))

(defun uws-comment-indent ()
  (generic-comment-indent "//" #'calc-uws-indent))

(defun uws-mode ()
  (interactive)
  (kill-all-local-variables)
  
  (setq buffer-mode 'uws-mode)
  (setq mode-name "uws")
  
  (use-keymap *uws-mode-map*)
  (use-syntax-table *uws-mode-syntax-table*)
  (make-local-variable 'mode-specific-indent-command)
  (setq mode-specific-indent-command 'uws-indent-line)
  (make-local-variable 'paragraph-start)
  (setq paragraph-start "^$\\|\f")
  (make-local-variable 'paragraph-separate)
  (setq paragraph-separate paragraph-start)
;;   (make-local-variable 'mode-specific-beginning-of-defun)
;;   (setq mode-specific-beginning-of-defun 'uws-beginning-of-defun)
;;   (make-local-variable 'mode-specific-end-of-defun)
;;   (setq mode-specific-end-of-defun 'uws-end-of-defun)
;;   (make-local-variable 'tags-find-target)
;;   (setq tags-find-target #'tags-find-target-simple)
;;   (make-local-variable 'tags-find-point)
;;   (setq tags-find-point #'tags-find-uws-point)
;;   (make-local-variable 'build-summary-function)
;;   (setq build-summary-function 'uws-build-summary-of-functions)
;;   (make-local-variable 'tags-case-insensitive)
;;   (setq tags-case-insensitive t)
  (and *uws-keyword-file*
       (null *uws-keyword-hash-table*)
       (setq *uws-keyword-hash-table*
	     (load-keyword-file *uws-keyword-file* t)))
  (when *uws-keyword-hash-table*
    (make-local-variable 'keyword-hash-table)
    (setq keyword-hash-table *uws-keyword-hash-table*)
    (unless *uws-keyword-cap-table*
      (setq *uws-keyword-cap-table* (make-hash-table :test #'equalp :size
						       (hash-table-size *uws-keyword-hash-table*)))
      (maphash #'(lambda (key val)
		   (setf (gethash key *uws-keyword-cap-table*) key))
	       *uws-keyword-hash-table*)))
  (setq *local-abbrev-table* *uws-mode-abbrev-table*)
  (setq comment-start "// ")
  (setq comment-end "")
  (setq comment-start-skip "//[ \t]*")
  (setq comment-indent-function 'uws-comment-indent)
  (when *uws-comment-column*
    (setq comment-column *uws-comment-column*))
  (run-hooks '*uws-mode-hook*))


;; ȉAbasic-mode 

#|
Do [{While | Until} condition]
  [statements]
  [Exit Do]
  [statements]
Loop

Do
  [statements]
  [Exit Do]
  [statements]
Loop [{While | Until} condition]

[Public | Private] Enum name
  membername [= constantexpression]
  membername [= constantexpression]
  ...
End Enum

For Each element In group
  [statements]
  [Exit For]
  [statements]
Next [element]

For counter = start To end [Step step]
  [statements]
  [Exit For]
  [statements]
Next [counter]

[Public | Private | Friend] [Static] Function name [(arglist)] [As type]
  [statements]
  [name = expression]
  [Exit Function]
  [statements]
  [name = expression]
End Function

If condition Then [statements][Else elsestatements]

If condition Then
  [statements]
[ElseIf condition-n Then
  [elseifstatements] ...
[Else
  [elsestatements]]
End If

Select Case testexpression
[Case expressionlist-n
  [statements-n]] ...
[Case Else
  [elsestatements]]
End Select

[Private | Public | Friend] [Static] Sub name [(arglist)]
  [statements]
  [Exit Sub]
  [statements]
End Sub

[Private | Public] Type varname
  elementname [([subscripts])] As type
  [elementname [([subscripts])] As type]
  ...
End Type

While condition
  [statements]
Wend

With object
  [statements]
End With

[Public | Private | Friend] [Static] Property Get name [(arglist)] [As type]
  [statements]
  [name = expression]
  [Exit Property]
  [statements]
  [name = expression]
End Property

[Public | Private | Friend] [Static] Property Let name ([arglist,] value)
  [statements]
  [Exit Property]
  [statements]
End Property

[Public | Private | Friend] [Static] Property Set name ([arglist,] reference)
  [statements]
  [Exit Property]
  [statements]
End Property

Begin name
  ...
End

BeginProperty name
  ...
EndProperty

|#

